/**
 * @file Drawer
 * @description
 * @author fex
 */
import React from 'react';
import { ClassNamesFn } from '../theme';
declare type DrawerPosition = 'top' | 'right' | 'bottom' | 'left';
export interface DrawerProps {
    className?: string;
    bodyClassName?: string;
    size: any;
    overlay: boolean;
    onHide: (e: any) => void;
    closeOnEsc?: boolean;
    container: any;
    show?: boolean;
    position: DrawerPosition;
    disabled?: boolean;
    closeOnOutside?: boolean;
    classPrefix: string;
    classnames: ClassNamesFn;
    onExited?: () => void;
    onEntered?: () => void;
}
export interface DrawerState {
}
export declare class Drawer extends React.Component<DrawerProps, DrawerState> {
    static defaultProps: Pick<DrawerProps, 'container' | 'position' | 'size' | 'overlay'>;
    modalDom: HTMLElement;
    contentDom: HTMLElement;
    isRootClosed: boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    contentRef: (ref: any) => any;
    handleEntered: () => void;
    handleExited: () => void;
    modalRef: (ref: any) => void;
    handleRootClickCapture(e: MouseEvent): void;
    handleRootClick(e: MouseEvent): void;
    render(): JSX.Element;
}
declare const _default: React.ComponentClass<Pick<Pick<DrawerProps, "show" | "disabled" | "className" | "onHide" | "onEntered" | "onExited" | "classPrefix" | "classnames" | "closeOnEsc" | "bodyClassName" | "closeOnOutside"> & Partial<Pick<DrawerProps, "overlay" | "size" | "container" | "position">> & Partial<Pick<Pick<DrawerProps, "overlay" | "size" | "container" | "position">, never>>, "show" | "disabled" | "overlay" | "size" | "className" | "onHide" | "container" | "onEntered" | "onExited" | "closeOnEsc" | "position" | "bodyClassName" | "closeOnOutside"> & {
    theme?: string | undefined;
    classPrefix?: string | undefined;
    classnames?: ClassNamesFn | undefined;
}, any> & {
    ComposedComponent: typeof Drawer;
};
export default _default;
